#include <LiquidCrystal_I2C.h>
#define DISPLAY_W 16

LiquidCrystal_I2C lcd(0x27,DISPLAY_W,2);  // set the LCD address to 0x27 for a 16 chars and 2 line display
 //SDA is Analog pin 4 on UNO
 //SCL is Analog pin 5 on UNO

int revolutions=0;
float rpm=0; // max value 32,767 16 bit
long  startTime=0;
long  elapsedTime;
bool triggered = false;
const int threshold = 580; 
const long measTime = 5000;

void setup() 
{
    pinMode(2, INPUT_PULLUP);           // set pin to input
    lcd.init();
    lcd.backlight();
    lcd.setCursor(0,0);
    lcd.print("RPM :"); 
    Serial.begin(9600);
    startTime = millis();
}
 
void loop() {
  int meas = analogRead(A0);
  if ( ( meas > threshold ) && (triggered == false) ){
    triggered = true;
    revolutions++;
  } else if ( (meas < threshold) && (triggered == true) ){
    triggered = false;
  }

  if ((millis() - startTime) > measTime){
    rpm= (((float)revolutions) * 60000.0) / (float) measTime;
    lcd.clear(); 
    lcd.setCursor(0,0);
    String outMsg = String("RPM :") + (String) rpm;
    fillMessage2DisplayWidth(outMsg);
    lcd.print(outMsg);
    Serial.println(outMsg);
    revolutions = 0;
    startTime = millis();
  }
}

  


void fillMessage2DisplayWidth(String & message)
{
  if(message.length()<DISPLAY_W+1)
  {
    while(message.length()<DISPLAY_W)
    {
      message+=" "; 
    }
     return;
  }
   //message is too wide for 1 line of the display, truncate it
    message = message.substring(0, DISPLAY_W-1); 
}
